"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
const utils_1 = require("fastcar-core/utils");
const RpcMetaData_1 = require("../constant/RpcMetaData");
function RPC(url) {
    return function (target) {
        let tname = utils_1.FormatStr.formatFirstToLow(target.name);
        let headUrl = url || tname;
        if (!headUrl.startsWith("/")) {
            headUrl = "/" + headUrl;
        }
        let routerMap = Reflect.getMetadata(RpcMetaData_1.RpcMetaData.RPCMethod, target.prototype);
        if (!!routerMap) {
            let newRouterMap = new Map();
            routerMap.forEach((item) => {
                let url = headUrl + item.url;
                newRouterMap.set(url, { url, method: item.method });
            });
            routerMap.clear();
            Reflect.defineMetadata(RpcMetaData_1.RpcMetaData.RPCMethod, newRouterMap, target.prototype);
        }
    };
}
exports.default = RPC;
