"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const annotation_1 = require("fastcar-core/annotation");
const RpcMetaData_1 = require("../constant/RpcMetaData");
const utils_1 = require("fastcar-core/utils");
//声明这是一个rpc验证的服务
function RPCAuth(target) {
    if (!Reflect.has(target.prototype, "auth")) {
        throw new Error("rpc auth method not implemented");
    }
    let auth = Reflect.get(target.prototype, "auth");
    if (!utils_1.TypeUtil.isFunction(auth)) {
        throw new Error("rpc auth property is not a method");
    }
    //声明为组件
    (0, annotation_1.Component)(target);
    //声明别名确保可以找到
    (0, annotation_1.BeanName)(RpcMetaData_1.RpcMetaData.RPCAuthService);
}
exports.default = RPCAuth;
