"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const annotation_1 = require("fastcar-core/annotation");
const RpcMetaData_1 = require("../constant/RpcMetaData");
const utils_1 = require("fastcar-core/utils");
function RPCError(target) {
    if (!Reflect.has(target.prototype, "response")) {
        throw new Error("rpc response method not implemented");
    }
    let response = Reflect.get(target.prototype, "response");
    if (!utils_1.TypeUtil.isFunction(response)) {
        throw new Error("rpc response property is not a method");
    }
    //声明为组件
    (0, annotation_1.Component)(target);
    //声明别名确保可以找到
    (0, annotation_1.BeanName)(RpcMetaData_1.RpcMetaData.RPCErrorService);
}
exports.default = RPCError;
