"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
const RpcMetaData_1 = require("../constant/RpcMetaData");
function RPCMethod(url) {
    return function (target, name, descriptor) {
        //默认取方法名
        if (!url) {
            url = name;
        }
        //格式化url 以/开头
        if (!url.startsWith("/")) {
            url = "/" + url;
        }
        let routerMap = Reflect.getMetadata(RpcMetaData_1.RpcMetaData.RPCMethod, target);
        if (!routerMap) {
            routerMap = new Map();
            Reflect.defineMetadata(RpcMetaData_1.RpcMetaData.RPCMethod, routerMap, target);
        }
        let curr = routerMap.get(url);
        if (!curr) {
            routerMap.set(url, {
                url,
                method: name,
            });
        }
        else {
            if (url != curr.url) {
                console.warn(`The two URL names are inconsisten in (${name},${curr.method})`);
            }
        }
    };
}
exports.default = RPCMethod;
