"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const RpcMetaData_1 = require("../constant/RpcMetaData");
//加载rpc组件
function RPCMiddleware(...args) {
    return function (target) {
        let middlewareList = Reflect.get(target.prototype, RpcMetaData_1.RpcMetaData.RPCMIDDLEWARE);
        if (!middlewareList) {
            middlewareList = args;
        }
        else {
            //由于注解方式是从下至上运行 和我们理解的书写习惯不一样，所以这边做了一个反序
            middlewareList = [...args, ...middlewareList];
        }
        Reflect.set(target.prototype, RpcMetaData_1.RpcMetaData.RPCMIDDLEWARE, middlewareList);
    };
}
exports.default = RPCMiddleware;
