"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DecodePBGrpcDefault = exports.EncodePBGrpcDefault = exports.DecodePBDefault = exports.EncodePBDefault = exports.DecodeDefault = exports.EncodeDefault = void 0;
const RpcConfig_1 = require("../types/RpcConfig");
const ProtoBuffService_1 = require("../service/ProtoBuffService");
const utils_1 = require("fastcar-core/utils");
const EncodeDefault = (msg) => {
    return JSON.stringify(msg);
};
exports.EncodeDefault = EncodeDefault;
const DecodeDefault = (msg) => {
    if (Buffer.isBuffer(msg)) {
        msg = msg.toString();
    }
    if (typeof msg == "string") {
        try {
            let obj = JSON.parse(msg);
            if (!!obj && typeof obj === "object") {
                return obj;
            }
        }
        catch (e) { }
    }
    return msg;
};
exports.DecodeDefault = DecodeDefault;
//关于protobuff的压缩
const EncodePBDefault = (msg) => {
    //先翻译data的数据
    let data = {
        url: msg.url,
        mode: msg.mode,
    };
    if (utils_1.ValidationUtil.isNotNull(msg.data) && msg.data) {
        data.data = ProtoBuffService_1.default.encode(msg.data, msg.url, RpcConfig_1.InteractiveMode.request == msg.mode);
    }
    if (utils_1.ValidationUtil.isNotNull(msg.id)) {
        data.id = msg.id;
    }
    let tests = ProtoBuffService_1.default.encodeRoute(data);
    //再整体计算
    return tests;
};
exports.EncodePBDefault = EncodePBDefault;
const DecodePBDefault = (msg) => {
    let data = ProtoBuffService_1.default.decodeRoute(msg);
    let bytes = data.data;
    if (utils_1.ValidationUtil.isNotNull(bytes)) {
        data.data = ProtoBuffService_1.default.decode(bytes, data.url, RpcConfig_1.InteractiveMode.request == data.mode);
    }
    return data;
};
exports.DecodePBDefault = DecodePBDefault;
//关于grpc的压缩
const EncodePBGrpcDefault = (msg) => {
    //先翻译data的数据
    let data = {
        url: msg.url,
        mode: msg.mode,
    };
    if (utils_1.ValidationUtil.isNotNull(msg.data) && msg.data) {
        data.data = ProtoBuffService_1.default.encode(msg.data, msg.url, RpcConfig_1.InteractiveMode.request == msg.mode);
    }
    if (utils_1.ValidationUtil.isNotNull(msg.id)) {
        data.id = msg.id;
    }
    //再整体计算
    return data;
};
exports.EncodePBGrpcDefault = EncodePBGrpcDefault;
const DecodePBGrpcDefault = (data) => {
    let bytes = data.data;
    if (utils_1.ValidationUtil.isNotNull(bytes)) {
        data.data = ProtoBuffService_1.default.decode(bytes, data.url, RpcConfig_1.InteractiveMode.request == data.mode);
    }
    return data;
};
exports.DecodePBGrpcDefault = DecodePBGrpcDefault;
