"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SocketClient = void 0;
const fastcar_core_1 = require("fastcar-core");
const annotation_1 = require("fastcar-core/annotation");
const SocketCodingDefault_1 = require("../../constant/SocketCodingDefault");
const CodeProtocolEnum_1 = require("../../types/CodeProtocolEnum");
//公用的socket
class SocketClient {
    constructor(config, manager) {
        this.sessionId = "";
        this.connected = false;
        this.config = config;
        this.manager = manager;
        //解码器赋值
        switch (config.codeProtocol) {
            case CodeProtocolEnum_1.CodeProtocolEnum.PROTOBUF: {
                this.encode = SocketCodingDefault_1.EncodePBDefault;
                this.decode = SocketCodingDefault_1.DecodePBDefault;
                break;
            }
            case CodeProtocolEnum_1.CodeProtocolEnum.JSON:
            default: {
                this.encode = SocketCodingDefault_1.EncodeDefault;
                this.decode = SocketCodingDefault_1.DecodeDefault;
                break;
            }
        }
        if (config.encode) {
            this.encode = config.encode;
        }
        if (config.decode) {
            this.decode = config.decode;
        }
        this.forceConnect = false;
    }
    getType() {
        return this.config.type;
    }
}
__decorate([
    (0, annotation_1.Log)("socket"),
    __metadata("design:type", fastcar_core_1.Logger)
], SocketClient.prototype, "logger", void 0);
exports.SocketClient = SocketClient;
