"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SocketClientFactory = exports.SocketServerFactory = void 0;
const SocketEnum_1 = require("../../constant/SocketEnum");
//仅按需加载模块
function SocketServerFactory(type) {
    switch (type) {
        case SocketEnum_1.SocketEnum.SocketIO: {
            return require("./impl/io/IoSocketServer").default;
        }
        case SocketEnum_1.SocketEnum.MQTT: {
            return require("./impl/mqtt/MqttSocketServer").default;
        }
        case SocketEnum_1.SocketEnum.WS: {
            return require("./impl/ws/WsSocketServer").default;
        }
        case SocketEnum_1.SocketEnum.Grpc: {
            return require("./impl/grpc/GrpcServer").default;
        }
        default: {
            throw new Error(`Unable to support ${type}`);
        }
    }
}
exports.SocketServerFactory = SocketServerFactory;
function SocketClientFactory(type) {
    switch (type) {
        case SocketEnum_1.SocketEnum.SocketIO: {
            return require("./impl/io/IoSocketClient").default;
        }
        case SocketEnum_1.SocketEnum.MQTT: {
            return require("./impl/mqtt/MqttSocketClient").default;
        }
        case SocketEnum_1.SocketEnum.WS: {
            return require("./impl/ws/WsSocketClient").default;
        }
        case SocketEnum_1.SocketEnum.Grpc: {
            return require("./impl/grpc/GrpcClient").default;
        }
        default: {
            throw new Error(`Unable to support ${type}`);
        }
    }
}
exports.SocketClientFactory = SocketClientFactory;
